/*
FILE: EditCtrl.c
NOTE: The State Machine Wizard will add mapping macros between /*{{ and /*}}. Do NOT modify manually.
*/

#include "sme.h"
#include "EditCtrl.h"
#include "service.h"
#include "display.h"
#include "global.h"

SME_BEGIN_STATE_DEF(EditCtrl,EditCtrl)
	/*{{SME_STATE_DEF(EditCtrl,EditCtrl)*/
	SME_STATE_ENTRY_FUNC(EditCtrlEntry)
	SME_STATE_EXIT_FUNC(EditCtrlExit)
	SME_ON_EVENT(EVENT_KEY_LEFTSOFT,OnEditCtrlEVENT_KEY_LEFTSOFT,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_RIGHTSOFT,OnEditCtrlEVENT_KEY_RIGHTSOFT,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_1,OnEditCtrlEVENT_KEY_1,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_0,OnEditCtrlEVENT_KEY_0,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_2,OnEditCtrlEVENT_KEY_2,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_3,OnEditCtrlEVENT_KEY_3,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_4,OnEditCtrlEVENT_KEY_4,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_5,OnEditCtrlEVENT_KEY_5,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_6,OnEditCtrlEVENT_KEY_6,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_7,OnEditCtrlEVENT_KEY_7,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_8,OnEditCtrlEVENT_KEY_8,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_9,OnEditCtrlEVENT_KEY_9,SME_INTERNAL_TRAN)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

/*{{SME_STATE_STATETREE_SEPARATOR}}*/

SME_BEGIN_STATE_TREE_DEF(EditCtrl)
	/*{{SME_STATE_TREE_DEF(EditCtrl)*/
	SME_STATE(EditCtrl,EditCtrl,SME_INVALID_STATE,-1)
	/*}}SME_STATE_TREE_DEF*/
SME_END_STATE_TREE_DEF

/*{{SME_DEC_IMP_SEPARATOR}}*/

SME_APPLICATION_DEF(EditCtrl, "EditCtrl")

#define DIGIT_MAX_LEN 12

static SME_CHAR g_DigitBuffer[DIGIT_MAX_LEN]={0}; 

int EditCtrlUpdateDisplay();

int EditCtrlEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i;
	for(i=0;i<DIGIT_MAX_LEN;i++)
		g_DigitBuffer[i]=0;
	g_DigitBuffer[0]=Digit_Input;
	ClearScreen();
    UICtrlSetSoftkey(&SoftKey,SID_EDIT_DEL,EVENT_NULL,SID_EDIT_OK,EVENT_EDIT_OK);
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int EditCtrlExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	return 0;
}



int OnEditCtrlEVENT_KEY_LEFTSOFT(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	g_DigitBuffer[i-1]=0;
	ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}


int OnEditCtrlEVENT_KEY_RIGHTSOFT(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	/*Create EVENT_EDIT_OK event triggered by right softkey to its parent application. */
	UICtrlOnRightSoftKey(&SoftKey, SME_GET_APP_VAR(EditCtrl).pParent);
	SmeSetFocus(SME_GET_APP_VAR(EditCtrl).pParent);
	return 0;
}

int EditCtrlUpdateDisplay()
{
	ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int OnEditCtrlEVENT_KEY_0(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='0';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int OnEditCtrlEVENT_KEY_1(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='1';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
	
}

int OnEditCtrlEVENT_KEY_2(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='2';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
	return 0;
}


int OnEditCtrlEVENT_KEY_3(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='3';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int OnEditCtrlEVENT_KEY_4(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='4';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int OnEditCtrlEVENT_KEY_5(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='5';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int OnEditCtrlEVENT_KEY_6(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='6';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int OnEditCtrlEVENT_KEY_7(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='7';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int OnEditCtrlEVENT_KEY_8(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='8';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

int OnEditCtrlEVENT_KEY_9(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	int i=0;
	while(g_DigitBuffer[i]!=0)  i++;
	if(i==DIGIT_MAX_LEN-1) return 0;

    g_DigitBuffer[i]='9';
   
    ClearScreen();
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
    DrawTextStrAt(2,MODE_LEFT,g_DigitBuffer,DEFAULT_DIGIT_FONT,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,0,96,64,Buf);
	return 0;
}

