/*
FILE: ImageList.c
NOTE: The State Machine Wizard will add mapping macros between /*{{ and /*}}. Do NOT modify manually.
*/

#include "sme_debug.h"
#include "Service.h"
#include "display.h"
#include "ImageList.h"
#include "global.h"

SME_BEGIN_STATE_DEF(ImageList,ImageList)
	/*{{SME_STATE_DEF(ImageList,ImageList)*/
	SME_STATE_ENTRY_FUNC(ImageListEntry)
	SME_STATE_EXIT_FUNC(ImageListExit)
	SME_ON_EVENT(EVENT_KEY_LEFTSOFT,OnImageListEVENT_KEY_LEFTSOFT,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_RIGHTSOFT,OnImageListEVENT_KEY_RIGHTSOFT,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_UP,OnImageListEVENT_KEY_UP,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_KEY_DOWN,OnImageListEVENT_KEY_DOWN,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_IMAGE_OK,OnImageListEVENT_IMAGE_OK,SME_INTERNAL_TRAN)
	SME_ON_EVENT(EVENT_IMAGE_CANCEL,OnImageListEVENT_IMAGE_CANCEL,SME_INTERNAL_TRAN)
	/*}}SME_STATE_DEF*/
SME_END_STATE_DEF

/*{{SME_STATE_STATETREE_SEPARATOR}}*/

SME_BEGIN_STATE_TREE_DEF(ImageList)
	/*{{SME_STATE_TREE_DEF(ImageList)*/
	SME_STATE(ImageList,ImageList,SME_INVALID_STATE,-1)
	/*}}SME_STATE_TREE_DEF*/
SME_END_STATE_TREE_DEF

/*{{SME_DEC_IMP_SEPARATOR}}*/

SME_APPLICATION_DEF(ImageList, "ImageList")

long image_rc[5]={IDB_SMS,IDB_CONTACT,IDB_NETWORK,IDB_TOOL,IDB_EXIT};
long root_image_menu_id;
int image_menu_num,current_num;

void* pBlockForImage=NULL;

int ImageListEntry(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	POINTER_OF_MENU_DATA pMenuData;
	pBlockForImage=SmeMAlloc(16);
	current_num=0;
	root_image_menu_id=default_imagemenu;
	image_menu_num=GetMenuData(root_image_menu_id,0,&pMenuData);
	ImageListUpdateDisplay();
	UICtrlSetSoftkey(&SoftKey,SID_IMAGE_SKL,EVENT_IMAGE_CANCEL,SID_IMAGE_SKR,EVENT_IMAGE_OK);
	DrawSoftkey(&SoftKey,default_lang,default_font,DISPLAY_DEFAULT_PEN_COLOR);
	SrvUpdateDisplay(0,DISPLAY_SOFTKEY_SIZE_TOP,96,DISPLAY_SOFTKEY_SIZE_HEIGHT,Buf);
	return 0;
}

int ImageListExit(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	SmeMFree(pBlockForImage);
	return 0;
}

int ImageListUpdateDisplay()
{
	int pivot_pos=current_num;
	int up,down;
	ClearScreen();
	DrawImageMenu(root_image_menu_id,image_rc[pivot_pos],default_lang,default_font,pivot_pos,DISPLAY_DEFAULT_PEN_COLOR);
	DrawBitmap(88,0,IDB_ROLL);
	up=9+(int)((float)current_num/image_menu_num*29);
	down=38-(int)((float)(image_menu_num-current_num-1)/image_menu_num*29);
	DrawRectangle(88,up,95,down,0xfc);
	SrvUpdateDisplay(0,0,96,DISPLAY_TEXTAREA_SIZE_HEIGHT,Buf);
	return 0;
}

int OnImageListEVENT_KEY_LEFTSOFT(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlLeftSoftKeyPress(&SoftKey);
	return 0;
}


int OnImageListEVENT_KEY_RIGHTSOFT(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlRightSoftKeyPress(&SoftKey);
	return 0;
}


int OnImageListEVENT_KEY_UP(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	if(current_num>0){
		current_num--;
		ImageListUpdateDisplay();
	}
	return 0;
}


int OnImageListEVENT_KEY_DOWN(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	if(current_num<image_menu_num-1){
		current_num++;
		ImageListUpdateDisplay();
	}
	return 0;
}


int OnImageListEVENT_IMAGE_OK(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	POINTER_OF_MENU_DATA pMenuData;
	SME_EVENT_T *pInteralEvent;
	GetMenuData(root_image_menu_id,current_num,&pMenuData);
	if(pMenuData->nSubMenuID>=0)
		pInteralEvent=SmeCreateIntEvent(EVENT_IMAGE_OPEN,pMenuData->nSubMenuID,0,SME_EVENT_CAT_UI,pApp->pParent);
	else
		pInteralEvent=SmeCreateIntEvent(EVENT_IMAGE_FUNC,pMenuData->nMenuTitleID,0,SME_EVENT_CAT_UI,pApp->pParent);
	SmePostEvent(pInteralEvent);
	return 0;
}


int OnImageListEVENT_IMAGE_CANCEL(struct SME_APP_T *pApp, struct SME_EVENT_T *pEvent)
{
	UICtrlPostInternalEvent(EVENT_IMAGE_EXIT,pApp->pParent);
	return 0;
}

