// SimulatorDlg.h : header file
//

#if !defined(AFX_SIMULATORDLG_H__38A32535_33A4_4BED_BE43_9AA33693EBF7__INCLUDED_)
#define AFX_SIMULATORDLG_H__38A32535_33A4_4BED_BE43_9AA33693EBF7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"
#include "DispCtrl.h"
#include "ColorPalette.h"
#include "Service.h"
#include "SrvAgent.h"
#include "Sme_debug.h"
#include "clock.h"

/////////////////////////////////////////////////////////////////////////////
// CSimulatorDlg dialog

#define DISP_WIDTH  96
#define DISP_HEIGHT  64

#define WM_DEBUG_STR_ID (WM_USER + 2)

class CSimulatorDlg : public CDialog
{
// Construction
public:
	CSimulatorDlg(CWnd* pParent = NULL);	// standard constructor
	friend void MyOutputDbgStrProc(const SME_CHAR * sDebugStr);

// Dialog Data
	//{{AFX_DATA(CSimulatorDlg)
	enum { IDD = IDD_SIMULATOR_DIALOG };
	CListCtrl	m_trace;
	CDispCtrl m_Display;
	CString	m_sMemSize;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSimulatorDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	unsigned int m_nMemSize;
	BOOL m_bTurnOn;
	BOOL m_bIdle;
	int m_event_id;
	unsigned int m_clk_id;
	unsigned int m_timer_id;
	SME_CHAR * m_event_str;
	Clock myClk;

	void OnButtonKeyPress(int nKeyCode);
	BOOL PowerControl();
	BOOL ClearDisplay();
	BOOL TurnOffDisplay();
	BOOL UpdateDisplay(void *pCallData, int nSize);
	BOOL UpdateMemSize(void *pCallData);

	// Generated message map functions
	//{{AFX_MSG(CSimulatorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonOnOff();
	afx_msg LRESULT OnSrvCall(WPARAM, LPARAM);
	afx_msg LRESULT OnDebugStr(WPARAM,LPARAM);
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnButton5();
	afx_msg void OnButton6();
	afx_msg void OnButton7();
	afx_msg void OnButton8();
	afx_msg void OnButton9();
	afx_msg void OnButton11();
	afx_msg void OnButtonLeftSoft();
	afx_msg void OnButtonRightSoft();
	afx_msg void OnButtonUp();
	afx_msg void OnButtonDown();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SIMULATORDLG_H__38A32535_33A4_4BED_BE43_9AA33693EBF7__INCLUDED_)
